<?php

class OrmCreator
{

    private $DatabaseConection;
    private $Agruments;

    public function start($argv)
    {
        $this->Agruments = $argv;
        printf(__FILE__);

        if (in_array($argv[1], array('--help', '-help', '-h', '-?')))
        {
            $this->showHelp();
            return;
        }
        switch ($argv[1])
        {

            case "-f": // create form from tbl 
                {
                    $this->generateForm($argv[2]);
                }break;

            case "-fdb": // create form from tbl 
                {
                    $this->generateFormDB($argv[2]);
                }break;

            case "-c":
                {
                    $this->createClass();
                    die("");
                }break;

            case "-v":
                {
                    $this->getVersion();
                }break;

            case "-o":
                {
                    if (isset($argv[2]))
                    {
                        $this->createORM4Table($argv[2]);
                    } else
                    {
                        $this->createORM4Table();
                    }
                }break;

            case "-k":
                {
                    $this->compressFile();
                }break;

            case "-kj":
                {
                    $this->compressJs();
                }break;

            case "-q":
                {
                    printf("Programm beendet");
                    die("");
                }break;

            case "-cdb":
                {
                    $this->checkDataBaseConnection();
                }break;

            case "-cdborm": // create database 
                {
                    $this->generateORMFromDatabase();
                }break;




            default:

                $this->showHelp();
                die("");
        }
    }

    public function checkDataBaseConnection()
    {
        require_once ("../cfg/cfg.php");
        require_once ("../class/db/cls_abstractDb.php");
        require_once ("../class/db/cls_dbpdo.php");
        require_once ("../class/lib/cls_logger.php");

        $this->DatabaseConection = PdoDataBase::getInstance();

        $this->DatabaseConection->connect(); // zu datenbank verbinden
        if (!$this->DatabaseConection->connect())
        {
            printf("Es konnte keine Verbindung zum Datenbank-Server aufgebaut werden!\n");
            printf("Bitte prüfen Sie die Datenbank einstellungen.\n");
            return false;
        }
        printf("\n\nDatenbank-Verbindung wurde aufgebaut!\n\n");
//$this->MySql->close();
        return true;
    }

    public function compressJs()
    {
        $Index = file_get_contents("../index.hmtl");

        printf("not implemented!\n");
    }

    public function compressFile()
    {
        printf("\ngeben Sie den absoluten Pfad zur Datei an, die komprimiert werden soll\n");
        $Path = $this->getInput();
        $StartSize = filesize($Path);
        $Data = file_get_contents($Path); // datei laden
// bei js datein alle var xx sichern
        $Data = str_replace("var ", "/*var*/", $Data);
        $Data = str_replace(" ", "", $Data);
        $Data = str_replace("\r\n", "", $Data);
        $Data = str_replace("\n", "", $Data);
        $Data = str_replace("/*var*/", "var ", $Data);
        file_put_contents($Path, $Data); // datei schreiben
        $EndSize = filesize($Path);
        $Percent = $EndSize / $StartSize;
        printf("die datei wurde Komprimiert um " . $Percent . " %\n");
    }

    public function generateORMFromDatabase()
    {
        if (!$this->checkDataBaseConnection())
        {
            return;
        }

        printf("\nnach der verbindung\n");

        $Sql = "SHOW Tables FROM " . DB_DATABASE;
        $Result = $this->DatabaseConection->executeQuery($Sql);
//$Fields=$Result['Field'];
        print_r($Result);
        print_r("\n\n");
        print_r($Sql);
        print_r("\n\n");

        foreach ($Result as $Table)
        {
            $TableName = $Table['Tables_in_' . DB_DATABASE];
            print_r($TableName);
            $this->createORM4Table($TableName);

//exit();
        }
    }

    /**
      erzeugt aus der angegeben mysql tabele eine php, js klasse + Finder und manager
     */
    public function createORM4Table($TableName = "")
    {
        /* require_once ("../class/db/cls_mysql.php");// mysql includieren
          $this->MySql= MySqldb::getInstance();// db instanze afmachen
          $this->MySql->connect();// zu datenbank verbinden
          if(!$this->MySql->connect())
          {
          printf("es konnte keine verbindung zum Datenbank server aufgebaut werden!\n");
          return false;
          } */


        if (!$this->DatabaseConection)
        {
            $this->checkDataBaseConnection(); // open database Connection
        }

        if (strlen($TableName) == 0)
        {
            echo getcwd() . "\n";
            printf("Geben Sie den Tabellen namen an der gemappt werden soll\n");
            $TableName = $this->getInput();
        }
        $ClearTableName = $this->clearDatabaseNames($TableName);
        $Sql = "SHOW COLUMNS FROM " . $TableName;
        $Result = $this->DatabaseConection->executeQuery($Sql);
        $Fields = array();
        foreach ($Result as $Column)
        {
            $Fields[] = $Column['Field'];
        }

        $this->createPHPClass($ClearTableName, $Fields);
        $this->createPHPCollectionClass($ClearTableName, $Fields);
        $this->createJSClass($ClearTableName, $Fields);

        $this->createManager($TableName, $Fields);
        $this->createFinder($TableName, $Fields);
// erstelle finder und manager

        $this->registerORMGeneratedClasses($TableName);
// klassen im autolod registrieren
//$this->MySql->close();
    }

    private function getPrefix($Name)
    {
        $Split = explode("_", $Name);
        return $Split[0];
    }

    /*
     * removed all Prefexes from table names
     */

    private function clearDatabaseNames($Name)
    {
        $Replacment = array(
            "i_",
            "d_",
            "b_",
            "t_",
            "tbl_",
            "Tbl_",
            "v_",
            "s_",
            "t_",
            "f_"
        );
        $Name = str_replace($Replacment, "", $Name);
        return $Name;
    }

    private function registerORMGeneratedClasses($TableName)
    {
        $TableName = ucfirst($this->clearDatabaseNames($TableName));
        $Path = pathinfo($this->Agruments[0]);
        $IncludeData = file_get_contents($Path['dirname'] . "/../class/logic/cls_Include.php");

// die letzte zeile entfernen
        $file = explode("\n", $IncludeData);
        $number = Count($file) - 1;
        unset($file[$number]);
        unset($file[$number + 1]);
        $IncludeData = implode("\n", $file);
// include lesen
// datein anfügen
        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('" . $TableName . "Manager','class/DatabaseObjects/cls_" . $TableName . "Manager.php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('" . $TableName . "Manager','class/DatabaseObjects/cls_" . $TableName . "Manager.php');\n";
        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('Base" . $TableName . "Manager','class/DatabaseObjects/base/cls_Base" . $TableName . "Manager.php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('Base" . $TableName . "Manager','class/DatabaseObjects/base/cls_Base" . $TableName . "Manager.php');\n";

        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('" . $TableName . "Finder','class/DatabaseObjects/cls_" . $TableName . "Finder.php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('" . $TableName . "Finder','class/DatabaseObjects/cls_" . $TableName . "Finder.php');\n";
        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('Base" . $TableName . "Finder','class/DatabaseObjects/base/cls_Base" . $TableName . "Finder.php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('Base" . $TableName . "Finder','class/DatabaseObjects/base/cls_Base" . $TableName . "Finder.php');\n";



        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('" . $TableName . "Collection','class/objects/cls_" . $TableName . "Collection.php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('" . $TableName . "Collection','class/objects/cls_" . $TableName . "Collection.php');\n";
        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('Base" . $TableName . "Collection','class/objects/base/cls_Base" . $TableName . "Collection.php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('Base" . $TableName . "Collection','class/objects/base/cls_Base" . $TableName . "Collection.php');\n";

        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('" . $TableName . "','class/objects/cls_" . $TableName . ".php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('" . $TableName . "','class/objects/cls_" . $TableName . ".php');\n";
        if (strpos($IncludeData, "Basic_include_const::getInstance()->addPath('Base" . $TableName . "','class/objects/base/cls_Base" . $TableName . ".php');") === false)
            $IncludeData .= "Basic_include_const::getInstance()->addPath('Base" . $TableName . "','class/objects/base/cls_Base" . $TableName . ".php');\n";


//datei schreiben

        $IncludeData .= "\n?>";
        /* $this->PathArray['PictureManager']='class/DatabaseObjects/cls_PictureManager.php';
          $this->PathArray['PictureFinder']='class/DatabaseObjects/cls_PictureFinder.php';
          $this->PathArray['Picture']='class/objects/cls_Picture.php';
          $this->PathArray['PictureCollection']='class/objects/cls_PictureCollection.php'; */
        file_put_contents($Path['dirname'] . "/../class/logic/cls_Include.php", $IncludeData); // includ datei schreiben
        printf("Komponenten wurden registriert\n");
    }

    private function removeCreateDate($FieldsArray)
    {
        $Key = array_search("d_CreateDate", $FieldsArray);
        if ($Key)
        {
            unset($FieldsArray[$Key]);
        }
        return $FieldsArray;
    }

    private function createManager($ClassName, $Fields)
    {
        $ClearName = ucfirst($this->clearDatabaseNames($ClassName));
        $Fields = $this->removeCreateDate($Fields); // wentfernt das createdate
        $SmallClassName = strtolower($ClassName);
        $Class = "<?php\n";
        $Class .= "class Base" . $ClearName . "Manager extends SystemManager\n{\n";

// Konstruktor anfang
        $Class .= "\n\tfunction __construct(";
        $Class .= ")\n\t{\n";
        $Class .= "\t\tparent::__construct();\n";
        $Class .= "\t}\n\n";
// konstruktor ende	
// insert fkt
        $Class .= "\tpublic function insert" . $ClearName . "(Base" . $ClearName . " %" . $ClearName . ")\n";
        $Class .= "\t{\n";
        $Class .= "\t	%Sql=\"INSERT INTO `" . $SmallClassName . "`\n ";

        $Class .= "\t\t(" . implode(",", $Fields) . ")\n";


        $Class .= "\t	VALUES \n";
        $Class .= "\t	(\n";
        $i = 0;
        foreach ($Fields as $Field)
        {
            if (0 != $i && $i != count($Fields))
            {
                $Class .= ",\n";
            }
            $i++;
            $Class .= "\t\t'\".%" . $ClearName . "->get" . $this->clearDatabaseNames($Field) . "().\"'";
        }
        $Class .= "\t\t)\";\n";
        $Class .= "\t	return %this->MySql->executeNoneQuery(%Sql);\n";
        $Class .= "\t}\n";

// update fk

        $Class .= "\tpublic function update" . $ClearName . "(Base" . $ClearName . " %" . $ClearName . ")\n";
        $Class .= "\t{\n";
        $Class .= "\t	%Sql=\"UPDATE `" . $SmallClassName . "` SET 	\n";
        $i = 0;
        foreach ($Fields as $Field)
        {
            if (0 != $i && $i != count($Fields))
            {
                $Class .= ",\n";
            }
            $i++;
            $Class .= "\t\t" . $Field . "='\".%" . $ClearName . "->get" . $this->clearDatabaseNames($Field) . "().\"'";
        }
        $Class .= "\tWHERE `i_Id` =\".%" . $ClearName . "->getId();\n";
        $Class .= "\t\treturn %this->MySql->executeNoneQuery(%Sql);\n";
        $Class .= "\t}\n";
// delete fkt	
        $Class .= "\tpublic function delete" . $ClearName . "(base" . $ClearName . " %" . $ClearName . ")\n";
        $Class .= "\t{\n";
        $Class .= "\t	%Sql=\"DELETE FROM `" . $SmallClassName . "` WHERE `i_Id` =\".%" . $ClearName . "->getId();\n";
        $Class .= "\t\treturn %this->MySql->executeNoneQuery(%Sql);\n";
        $Class .= "\t}\n";
        $Class .= "}
?>";
// klasse zu ende
        $Class = str_replace("%", "$", $Class);

        printf($this->Agruments[0]);

        $Path = pathinfo($this->Agruments[0]);
        if (!is_dir($Path['dirname'] . "/../class/DatabaseObjects/base"))
        {
            mkdir($Path['dirname'] . "/../class/DatabaseObjects/base");
        }
        file_put_contents($Path['dirname'] . "/../class/DatabaseObjects/base/cls_Base" . $ClearName . "Manager.php", $Class);
        printf("PHP Class created >> " . $Path['dirname'] . "/../class/DatabaseObjects/base/cls_" . $ClearName . "Manager.php\n");

        if (file_exists($Path['dirname'] . "/../class/DatabaseObjects/cls_" . $ClearName . "Manager.php"))
            return;
// create the file for user edit
        $Class = "<?php\n";
        $Class .= "class " . $ClearName . "Manager extends Base" . $ClearName . "Manager\n{\n\n";
        $Class .= "}\n";
        $Class .= "?>";
        file_put_contents($Path['dirname'] . "/../class/DatabaseObjects/cls_" . $ClearName . "Manager.php", $Class);
        printf("PHP Manager Class created >> cls_" . $ClearName . "Manager.php\n");
    }

    private function createFinder($ClassName, $Fields)
    {
        $ClearName = ucfirst($this->clearDatabaseNames($ClassName));
        $ClassNameOld = $ClassName;
        $SmallClassName = strtolower($ClassName);
        $Class = "<?php\n";
        $Class .= "class Base" . $ClearName . "Finder extends SystemFinder\n{\n";
// Konstruktor anfang
        $Class .= "\tfunction __construct(";
        $Class .= ")\n\t{\n";
        $Class .= "\t\tparent::__construct();\n";
        $Class .= "\t}\n\n";
// konstruktor ende	
// doload

        $Class .= "\tprotected function doLoad(%RecordSet)
	{
		%" . $ClearName . "Collection = new " . $ClearName . "Collection();
		foreach (%RecordSet as %Row)
		{
			%" . $ClearName . "Collection->add(%this->load(%Row));
		}
		return %" . $ClearName . "Collection;
	}\n\n";

        $TempArray = array(); // das array aufbereiten
        foreach ($Fields as $Field)
        {
            $TempArray[] = "%Row['" . $Field . "']";
        }
        $Class .= "\tprotected function load(%Row)
	{
		return new " . $ClearName . "(" . implode(",", $TempArray) . ");
	}\n\n";


        $Class .= "\tpublic function findAll()
        {
            %Sql =\"select  " . implode(",", $Fields) . "
                    from $SmallClassName\";
            return %this->doLoad(%this->MySql->executeQuery(%Sql));
        }\n\n";




        $i = 0;
        foreach ($Fields as $Field)
        {
            $FieldClear = ucfirst($this->clearDatabaseNames($Field));
            $Class .= "\tpublic function findBy" . $FieldClear . "(%" . $FieldClear . ")
	{
		%Sql=\"select " . implode(",", $Fields) . "
		from " . $SmallClassName . "
		where " . $Field . " = '\".%" . $FieldClear . ".\"'\";\n";
            if ($i == 0)
            {
                $Class .= "\t\treturn %this->doLoad(%this->MySql->executeQuery(%Sql))->getByIndex(0);\n";
            } else
            {
                $Class .= "\t\treturn %this->doLoad(%this->MySql->executeQuery(%Sql));\n";
            }
            $i++;
            $Class .= "\t}\n\n";
        }
        $Class .= "}
		?>";
// klasse zu ende
        $Class = str_replace("%", "$", $Class);
        printf($this->Agruments[0]);
        $Path = pathinfo($this->Agruments[0]);
        if (!is_dir($Path['dirname'] . "/../class/DatabaseObjects/base"))
        {
            mkdir($Path['dirname'] . "/../class/DatabaseObjects/base");
        }
        file_put_contents($Path['dirname'] . "/../class/DatabaseObjects/base/cls_Base" . $ClearName . "Finder.php", $Class);
        printf("PHP Class created >> " . $Path['dirname'] . "/../class/DatabaseObjects/cls_Base" . $ClearName . "Finder.php\n");


        if (file_exists($Path['dirname'] . "/../class/DatabaseObjects/cls_" . $ClearName . "Finder.php"))
            return;
// create the file for user edit
        $Class = "<?php\n";
        $Class .= "class " . $ClearName . "Finder extends Base" . $ClearName . "Finder\n{\n\n";
        $Class .= "}\n";
        $Class .= "?>";
        file_put_contents($Path['dirname'] . "/../class/DatabaseObjects/cls_" . $ClearName . "Finder.php", $Class);
        printf("PHP Finder Class created >> cls_" . $ClearName . "Finder.php\n");
    }

    public function createClass()
    {
        printf("Erstellen einer neuen Klasse\n");
        printf("geben Sie den Namen der Klasse an:\n");
        $ClassName = $this->getInput();
        $MemberVariablen = array();

        $NewVar = true;
        do
        {
            printf("Member Variablen name:\n");
            $MemberVariablen[] = $this->getInput(); // member hinzufügen

            printf("weiteren meber hinzufügen: Y/N\n");
            $NewVar = $this->getInput();
            if ($NewVar == "Y")
            {
                $NewVar = true;
            } else
            {
                $NewVar = false;
            }
        } while ($NewVar);

        $this->createPHPClass($ClassName, $MemberVariablen);
        $this->createPHPCollectionClass($ClassName, $MemberVariablen);
        $this->createJSClass($ClassName, $MemberVariablen);
    }

    private function createJSClass($ClassName, $MemberVariablen)
    {
        $ClassName = ucfirst($this->clearDatabaseNames($ClassName));
        $Class = $ClassName . "= function(Init)\n";
        $Class .= "{\n";

        foreach ($MemberVariablen as $Parameter)
        {
            $Parameter = $this->clearDatabaseNames($Parameter);
            $Class .= "\tthis." . $Parameter . "=(Init." . $Parameter . ") ? Init." . $Parameter . " : '';\n";
        }
        $Class .= "\t";

        foreach ($MemberVariablen as $Parameter)
        {
            $Parameter = $this->clearDatabaseNames($Parameter);
            $Class .= "\tthis.get" . $Parameter . " = function()\n";
            $Class .= "\t{\n";
            $Class .= "\t\treturn this." . $Parameter . ";\n";
            $Class .= "\t}\n\t";
            $Class .= "\tthis.set" . $Parameter . " = function(" . $Parameter . ")\n";
            $Class .= "\t{\n";
            $Class .= "\t\tthis." . $Parameter . "=" . $Parameter . ";\n";
            $Class .= "\t}\n\n";
        }
// getter und setter definieren
        $Class .= "}";
        $Path = pathinfo($this->Agruments[0]);
        @mkdir($Path['dirname'] . "/../js/objects/", "0777"); // fals der ordner nicht exsistiert dann hier neu stellen
        file_put_contents($Path['dirname'] . "/../js/objects/cls_" . $ClassName . ".js", $Class);
        printf("JS Class created >> cls_" . $ClassName . ".js\n");
    }

    private function createPHPCollectionClass($ClassName, $MemberVariablen)
    {
        $ClassName = ucfirst($this->clearDatabaseNames($ClassName));
        $Class = "<?php\n";
        $Class .= "class Base" . $ClassName . "Collection extends Collection  \n{\n";
        $Class .= "\tpublic function add(" . $ClassName . " %Element)
		{
			if(isset(%Element))
			{
				%this->Elements[]=%Element;
			}
		}\n";


        $Class .= "\tpublic function getById(%Id)
	{
		foreach (%this->Elements as %Element)
		{
			if(%Element->getId()==%Id)
			{
				return %Element;
			}
		}
		return " . $ClassName . "::getEmptyInstance();
	}\n";


        $Class .= "\tpublic function getByIndex(%Index)
	{
		if (!isset(%this->Elements[%Index]) || %this->countElements() <  0)
		{
			return " . $ClassName . "::getEmptyInstance();
		}
		return %this->Elements[%Index];	
	}\n";

        $Class .= "}
		?>";
// klasse zu ende
        $Class = str_replace("%", "$", $Class);
        $Path = pathinfo($this->Agruments[0]);
        if (!is_dir($Path['dirname'] . "/../class/objects/base"))
        {
            mkdir($Path['dirname'] . "/../class/objects/base");
        }
        file_put_contents($Path['dirname'] . "/../class/objects/base/cls_Base" . $ClassName . "Collection.php", $Class);
        printf("PHP Class created >> cls_Base" . $ClassName . "Collection.php\n");


        if (file_exists($Path['dirname'] . "/../class/objects/cls_" . $ClassName . "Collection.php"))
            return;
// create the file for user edit
        $Class = "<?php\n";
        $Class .= "class " . $ClassName . "Collection extends Base" . $ClassName . "Collection\n{\n\n";
        $Class .= "}\n";
        $Class .= "?>";
        file_put_contents($Path['dirname'] . "/../class/objects/cls_" . $ClassName . "Collection.php", $Class);
        printf("PHP collection Class created >> cls_" . $ClassName . "Collection.php\n");
    }

    /**
     * erzeugt eine php classe aus den übergeben daten
     */
    private function createPHPClass($ClassName, $MemberVariablen)
    {
        $ClassName = ucfirst($this->clearDatabaseNames($ClassName));
        $Class = "<?php\n";
        $Class .= "class Base" . $ClassName . " extends i_CollectionElement \n{\n";
        foreach ($MemberVariablen as $Parameter)
        {
            $Parameter = ucfirst($this->clearDatabaseNames($Parameter));
            $Class .= "\tprotected $" . $Parameter . ";\n";
        }
// Konstruktor anfang
        $Class .= "\n\tfunction __construct(";
        $i = 0;
        foreach ($MemberVariablen as $Parameter)
        {
            $Parameter = ucfirst($this->clearDatabaseNames($Parameter));
            $Class .= "$" . $Parameter;
            $i++;
            if ($i < count($MemberVariablen))
            {
                $Class .= ",";
            }
        }
        $Class .= ")\n\t{\n";

        $Class .= "\n";
        $Class .= "\t\tif (is_array(%Id))
        \t{
        \t\t%this->setValuesFromArray(%Id);
        \t\treturn;
        \t}
        ";
        $Class .= "\n\n";

        foreach ($MemberVariablen as $Parameter)
        {
            $Parameter = ucfirst($this->clearDatabaseNames($Parameter));
            $Class .= "\t\t%this->" . $Parameter . "=$" . $Parameter . ";\n";
        }

        $Class .= "\t}\n\n";
// konstruktor ende
// getter und setter definieren


        foreach ($MemberVariablen as $Parameter)
        {
            $Parameter = ucfirst($this->clearDatabaseNames($Parameter));
            $Class .= "\tpublic function get" . $Parameter . "()\n";
            $Class .= "\t{\n";
            $Class .= "\t\treturn %this->" . $Parameter . ";\n";
            $Class .= "\t}\n";
            $Class .= "\tpublic function set" . $Parameter . "($" . $Parameter . ")\n";
            $Class .= "\t{\n";
            $Class .= "\t\t%this->" . $Parameter . "=$" . $Parameter . ";\n";
            $Class .= "\t}\n\n";
        }
// getter und setter definieren

        $Class .= "\tpublic static function getEmptyInstance()\n";
        $Class .= "\t{\n";
        $Class .= "\t    return new " . $ClassName;

        $Class .= "(";
        $i = 0;
        foreach ($MemberVariablen as $Parameter)
        {
            $Parameter = ucfirst($this->clearDatabaseNames($Parameter));
            $Class .= "$" . $Parameter;
            $i++;
            if ($i < count($MemberVariablen))
            {
                $Class .= ",";
            }
        }
        $Class .= ");";
        $Class .= "\n";
        $Class .= "\t}\n";

        $Class .= "}
		?>";
// klasse zu ende
        $Class = str_replace("%", "$", $Class);
        $Path = pathinfo($this->Agruments[0]);
        if (!is_dir($Path['dirname'] . "/../class/objects/base"))
        {
            mkdir($Path['dirname'] . "/../class/objects/base");
        }
        file_put_contents($Path['dirname'] . "/../class/objects/base/cls_Base" . $ClassName . ".php", $Class);
        printf("PHP Class created >> cls_Base" . $ClassName . ".php\n");


        if (file_exists($Path['dirname'] . "/../class/objects/cls_" . $ClassName . ".php"))
            return;
// create the file for user edit
        $Class = "<?php\n";
        $Class .= "class " . $ClassName . " extends Base" . $ClassName . "\n{\n\n";
        $Class .= "}\n";
        $Class .= "?>";
        file_put_contents($Path['dirname'] . "/../class/objects/cls_" . $ClassName . ".php", $Class);
        printf("PHP Class created >> cls_" . $ClassName . ".php\n");
    }

    public function getVersion()
    {
        Printf("\nVersion: 1.3.0.1 \n");
        Printf("\nLast Edit: 28.01.2017 MH\n");
    }

    public function showHelp()
    {
        printf("\n\n*** Hilfe des ORM Creators ***\n\n");
        printf("bitte geben Sie einen der folgenden Parameter an.\n\n");
        printf("-c erstellen einer neuen Klasse PHP, JS\n");
        printf("-v gibt die version des generators zurueck\n");
        printf("-o erstellt ORM klassen fuer eine mysql Tabelle\n");
        printf("-k komprimiere JS oder css datei\n");
        printf("-kj durchsucht die index.html und komprimirt alle JS und css datei und legt diese in die main.js und main.css\n");
        printf("-cdb Prueft die Datenbank-Verbindung\n");
        printf("-cdborm erstellt den orm der aktuellen datenbank\n");
        printf("-f erstellt ein form von der angegeben Tabelle\n");
        printf("\n\n");
    }

    public function generateFormDB($DBName)
    {

        if (!$this->DatabaseConection)
        {
            $this->checkDataBaseConnection(); // open database Connection
        }

        if (strlen($DBName) == 0)
        {
            echo getcwd() . "\n";
            printf("Geben Sie den Datenbank-Namen an, der gemappt werden soll.\n");
            $DBName = $this->getInput();
        }


        $Sql = "SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' AND TABLE_SCHEMA = '" . $DBName . "'";

        $Result = $this->DatabaseConection->executeQuery($Sql);

        foreach ($Result as $TableName)
        {
            $this->generateForm($TableName["TABLE_NAME"]);
        }
    }

    public function generateForm($TableName)
    {
        if (!$this->DatabaseConection)
        {
            $this->checkDataBaseConnection(); // open database Connection
        }

        if (strlen($TableName) == 0)
        {
            echo getcwd() . "\n";
            printf("Geben Sie den Tabellennamen an, der gemappt werden soll.\n");
            $TableName = $this->getInput();
        }

        $Sql = "SHOW FULL COLUMNS FROM " . $TableName;
        $Result = $this->DatabaseConection->executeQuery($Sql);

        $ColumnsArray = $this->generateColumnsArray($Result);

        $this->writeForm($TableName, $ColumnsArray);
    }

    private function generateColumnsArray($Columns)
    {
        $ColumnsArray = array();

        foreach ($Columns as $Column)
        {
            $ThisColumn = array();



            // Wenn kein ";"-Zeichen in $Column['Comment'] vorhanden: $Column['Comment'] ist deutscher Bezeichner
            if (strpos($Column['Comment'], ";") === false)
            {
                $ThisColumn['Name'] = $Column['Field'];
                $ThisColumn['NameGer'] = $Column['Comment'];
            }
            // Sonst: $Column['Comment'] anhand von ";"-Zeichen zerlegen
            else
            {
                $ThisColumn['Name'] = $Column['Field'];
                //    $ThisColumn = $this->parseColumnComment($Column);
                $Temp = $this->parseColumnComment($Column);


                foreach ($Temp as $Key => $Value)
                {
                    $ThisColumn[$Key] = $Value;
                }
            }

            $ColumnsArray[] = $ThisColumn;
        }

        return $ColumnsArray;
    }

    private function parseColumnComment($Column)
    {
        $CommentArray = explode(";", $Column['Comment']);

        foreach ($CommentArray as $CommentPart)
        {
            $CommentPart = trim($CommentPart);

            // Jeden $CommentPart anhand von "="-Zeichen in $CommentKey und $CommentValue teilen
            $PositionEqualSign = strpos($CommentPart, '=');
            $CommentKey = trim(substr($CommentPart, 0, $PositionEqualSign));
            $CommentValue = trim(substr($CommentPart, $PositionEqualSign + 1));

            //  Wenn kein ","-Zeichen in $CommentValue vorhanden: $CommentValue ist ein String
            if (strpos($CommentValue, ",") === false)
            {
                $CommentValue = trim(str_replace('"', '', $CommentValue));
            } else
            // Sosnt: $CommentValue ist ein Array    
            {
                $CommentValue = array_map("trim", str_replace('"', '', explode(",", $CommentValue)));
            }

            $ColumnArrayPart[$CommentKey] = $CommentValue;
        }
        return $ColumnArrayPart;
    }

    private function writeForm($TableName, $Fields)
    {
        $Complete = $this->generateComplete($TableName, $Fields);

        $Path = pathinfo($this->Agruments[0]);

        $ClassName = ucfirst($this->clearDatabaseNames($TableName));

        if (!is_dir("generated"))
        {
            // from erstellen
            echo "\n ordner wird \n";
            mkdir("generated", 0700);
        }

        if (file_exists($Path['dirname'] . "/../utils/generated/tpl_" . $ClassName . ".php"))
        {
            echo "\nForm schon vorhanden!\n";
            file_put_contents($Path['dirname'] . "/../utils/generated/tpl_" . $ClassName . " " . date("y-m-d H-i") . ".php", $Complete);
            echo "Form erstellt: 'tpl_" . $ClassName . " " . date("y-m-d H-i") . ".php'";
        } else
        {
            file_put_contents($Path['dirname'] . "/../utils/generated/tpl_" . $ClassName . ".php", $Complete);
            echo "\nForm erstellt: tpl_" . $ClassName . ".php";
        }
    }

    /**
     * generiert das Formular mit header und footer
     * @param type $TabelString
     * @return type
     */
    private function generateComplete($TableName, $Fields)
    {
        $TemplateStart = $this->generateTemplateStart($TableName);
        $FormElements = $this->generateFormElements($Fields);
        $ControlButtons = $this->generateControlButtons();
        $TemplateEnd = $this->generateTemplateEnd();

        $Complete = $TemplateStart . $FormElements . $ControlButtons . $TemplateEnd;

        return $Complete;
    }

    private function generateTemplateStart($TableName)
    {
        $TemplateStart = '
    <!doctype html>
    <html>
        <head>
            <link rel="stylesheet" type="text/css" href="../../css/bootstrap.min.css">
            <link rel="stylesheet" type="text/css" href="../../css/screen.css">
        </head>
        <body>
        <div id="main" class="container">
        
<!-- Start tpl -->

            <form id="GeneratatedForm" 
                  class="form-horizontal" 
                  data-tablename="' . ucfirst($this->clearDatabaseNames($TableName)) . '"
                  enctype="multipart/form-data">
                <fieldset>

                <!-- Form Name -->
                <legend>' . ucfirst($this->clearDatabaseNames($TableName)) . '</legend>

                    <input id = "hidden_TableName" name = "hidden_TableName" type = "hidden" value = "<?php echo $this->$TableName; ?>" >
                    ';

        return $TemplateStart;
    }

    private function generateFormElements($Fields)
    {
        foreach ($Fields as $Field)
        {
            $Prefix = $this->getPrefix($Field['Name']);

            $Field['Name'] = $this->clearDatabaseNames($Field['Name']);

            $HiddenFields = array("Id", "CreateDate", "LastUpdate", "LastLogin", "LastLogout");
            $SearchFor = array(":Name:", ":NameGer:", ":Placeholder:");
            if (isset($Field['Placeholder']))
            {
                $ReplaceWith = array($Field['Name'], $Field['NameGer'], $Field['Placeholder']);
            } else
            {
                $ReplaceWith = array($Field['Name'], $Field['NameGer'], $Field['NameGer']);
            }
            $FormSnippet = $this->generateFormSnippet($Prefix, $Field, $HiddenFields);

            $FormElement = str_replace($SearchFor, $ReplaceWith, $FormSnippet);
            $FormElements .= $FormElement;
        }
        return $FormElements;
    }

    /**
     * 
     */
    private function getTableStringToFinder($TabelString)
    {
        $TabelString = str_replace("tbl_", "", $TabelString);
        return ucfirst($TabelString);
    }

    /**
     * �ndert das Prefix f�r Spezialfelder wie Passwort, Mail, File, ...
     * @param type $Field
     * @param type $Prefix
     * @return string
     */
    private function getFinalPrefix($Field, $Prefix)
    {
        if (isset($Field['Select']))
        {
            $Prefix = 'e';
        } else if (isset($Field['TableLink']))
        {
            $Prefix = 'tbl';
        } else if (isset($Field['File']))
        {
            $Prefix = 'f';
        } else if ($Field['Name'] == "Pass")
        {
            $Prefix = 'p';
        } else if ($Field['Name'] == "Mail")
        {
            $Prefix = 'm';
        }

        return $Prefix;
    }

    private function getPlaceholder($Field)
    {
        if (isset($Field['Placeholder']))
        {
            $Placeholder = $Field['Placeholder'];
        } else
        {
            $Placeholder = $Field['NameGer'];
        }

        return $Placeholder;
    }

    /**
     * erzeugt die einzelenen formular elemente
     * @param type $Prefix
     * @param type $Field
     * @param type $HiddenFields
     * @return string
     */
    private function generateFormSnippet($Prefix, $Field, $HiddenFields)
    {

        $FinalPrefix = $this->getFinalPrefix($Field, $Prefix);

        if (in_array($Field['Name'], $HiddenFields) || isset($Field['Hidden']))
        {
            $HiddenCSS = 'style="display:none;"';
        } else
        {
            $HiddenCSS = '';
        }


        if (isset($Field['Required']))
        {
            $Required = "required";
            $Star = "*";
        } else
        {
            $Required = "";
            $Star = "";
        }

        switch ($FinalPrefix)
        {

            case "b":
                $FormSnippet = '
            <!-- Select Basic (Ja-Nein) -->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="selectbasic">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <select id="s_:Name:" 
                            name="s_:Name:" 
                            data-type="s" 
                            class="form-control">
                      <option value="1" selected="selected">Ja</option>
                      <option value="2">Nein</option>
                    </select>
                  </div>
                </div>
                    ';
                break;


            case "s":
                $FormSnippet = ' 
            <!-- Input-Field -->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="textinput">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                  <input id="tb_:Name:" 
                         name="tb_:Name:" 
                         data-type="s" 
                         table-link=":TableLink:" 
                         type="text" 
                         placeholder=":Placeholder:" 
                         class="form-control input-md"
                         ' . $Required . '>
                  </div>
                </div>
            ';
                break;


            case "t":
                $FormSnippet = '
            <!-- Textarea -->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="textarea">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <textarea class="form-control" 
                              id="rtb_:Name:" 
                              name="rtb_:Name:" 
                              data-type="t"
                         ' . $Required . '></textarea>
                  </div>
                </div>
                    ';
                break;


            case "p":
                $FormSnippet = '
            <!-- Password input-->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="passwordinput">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <input id="tb_:Name:" 
                           name="tb_:Name:" 
                           data-type="s" 
                           type="password" 
                           placeholder=":Placeholder:" 
                           class="form-control 
                           input-md"
                         ' . $Required . '>
                  </div>
                </div>
                
            <!-- Password input-->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="passwordinput">:NameGer: wiederholen' . $Star . '</label>
                  <div class="col-md-6">
                    <input id="tb_:Name:_repeat" 
                           name="tb_:Name:_repeat" 
                           data-type="s" 
                           type="password" 
                           placeholder=":Placeholder: wiederholen" 
                           class="form-control 
                           input-md"
                         ' . $Required . '>
                  </div>
                </div>
            ';
                break;


            case "m":
                $FormSnippet = '
            <!-- Password input-->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="passwordinput">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <input id="tb_:Name:" 
                           name="tb_:Name:" 
                           data-type="s" 
                           type="text" 
                           placeholder=":Placeholder:" 
                           class="form-control input-md"
                           type="email" 
                           pattern="[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,3}$"                                                                      
                         ' . $Required . '>
                  </div>
                </div>
            ';


            case "d":
                $FormSnippet = '
            <!-- Datepicker -->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="textarea">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <input type="date" 
                           class="form-control" 
                           pattern="[0-9]{4}-[0-9]{2}-[0-9]{2}"  
                           id="tb_:Name:" 
                           name="tb_:Name:" 
                           data-type="d"
                         ' . $Required . '>
                  </div>
                </div>
                    ';
                break;


            case "e":
                foreach ($Field['Select'] as $Value)
                {
                    $Options .= '<option value="1">' . $Value . '</otion>';
                }

                $FormSnippet = '
            <!-- Select Basic -->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="selectbasic">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <select id="s_:Name:" 
                            name="s_:Name:" 
                            data-type="s" 
                            class="form-control">
                    '
                        . $Options .
                        '
                    </select>
                  </div>
                </div>
                    ';
                break;

            case "tbl":
                $FinderName = $this->getTableStringToFinder($Field['TableLink']);
                if (isset($Field['Where']))
                {
                    $ByName = $this->clearDatabaseNames($Field['Where']);
                }
                $DisplayName = $this->clearDatabaseNames($Field['TableLinkFields']);

                $FormSnippet = '
            <!-- Select Basic -->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="selectbasic">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <select id="s_:Name:" 
                            name="s_:Name:" 
                            data-type="s" 
                            class=" form-control">
                    '
                        . "
                        <?php
                        
                        echo \$this->getOptionHTMLElemtns('$FinderName','$DisplayName','$ByName', \$this->User->getId());
                        
                        ?>" .
                        '
                    </select>
                  </div>
                </div>';
                //              echo $FormSnippet;
                break;


            case "f":
                $FormSnippet = '
            <!-- Password input-->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="passwordinput">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                    <input id="tb_:Name:" 
                           name="tb_:Name:" 
                           data-type="s" 
                           type="file" 
                           placeholder=":Placeholder:" 
                           class="form-control 
                           input-md"
                         ' . $Required . '>
                  </div>
                </div>
            ';

                break;


            default:
                $FormSnippet = ' 
            <!-- Input-Field -->
                <div class="form-group row"  ' . $HiddenCSS . ' >
                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="textinput">:NameGer:' . $Star . '</label>
                  <div class="col-md-6">
                  <input id="tb_:Name:" 
                         name="tb_:Name:" 
                         data-type="s" 
                         table-link=":TableLink:" 
                         type="text" 
                         placeholder=":Placeholder:" 
                         class="form-control input-md"
                         ' . $Required . '>
                  </div>
                </div>
            ';
                break;
        }

        return $FormSnippet;

        // UNUSED....
        //        $CheckBox = '
        //            <!-- Multiple Checkboxes (inline) -->
        //                <div class="form-group row">
        //                  <label class="col-md-4 control-label generated-label text-md-right text-xs-left" for="checkboxes">:NameGer:' . $Star . '</label>
        //                  <div class="col-md-6">
        //                    <label class="checkbox-inline" for="checkboxes-0">
        //                      <input type="checkbox" name="cb_:Name:" id="cb_:Name:" value="1">
        //                      1
        //                    </label>
        //                  </div>
        //                </div>
        //                    ';
        // ....UNUSED
    }

    private function generateControlButtons()
    {
        $Buttons = '
            <!-- Button (Double) -->
                    <div class="form-group row">
                        <br />
                        <div class="col-md-2"></div>
                        <div class="col-md-8 row">      
                            <div class="col-md-6">
                                <input type="submit" id="btn_Controls0" name="btn_Controls0" class="btn btn-success btn-block" value="Speichern" />
                                <br />
                            </div>
                            <div class="col-md-6">
                                <a href="index.php?Section=">
                                    <button id="btn_:Name:1" name="btn_:Name:1" class="btn btn-danger btn-block"> verwerfen </button>
                                </a>
                            </div>
                      </div>
                    </div>
                        ';

        $ControlButtons = str_replace(":Name:", "Controls", $Buttons);

        return $ControlButtons;
    }

    private function generateTemplateEnd()
    {
        $TemplateEnd = '<script>

                    $(function()
                    {
                        Engine.setFromEvents();
                    });
                    </script>
                    <!-- end tpl -->
                </fieldset>
            </form>
        </div>';

        return $TemplateEnd;
    }

    private function getInput()
    {
        $Input = "";
        $stdin = fopen("php://stdin", "r");
        $Input = trim(fgets($stdin));
        fclose($stdin);
        return $Input;
    }

}

error_reporting(E_ALL & ~(E_STRICT | E_NOTICE));

$Generator = new OrmCreator();
$Generator->start($argv);
?>